////////////////////////////////////////////////////////////////////////
// multischedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.multischedule")

// <%pre>
#line 1 "multischedule.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <timers.h>
#include <epg_events.h>

using namespace vdrlive;

bool checkEpg(const cChannel *channel) {
// true if this channel must be displayed.
// this is true if:
// - the channel is not a group seperator
// - we also display channels without EPG or if this channel has EPG
  if (channel->GroupSep() ) return false;
  if (LiveSetup().GetShowChannelsWithoutEPG() ) return true;
  LOCK_SCHEDULES_READ;
  const cSchedule *channelSchedule = Schedules->GetSchedule(channel);
  return channelSchedule && (channelSchedule->Events()->First() );
}

enum class tState {
  None,
  Inactive,
  Active,
  Recording
};

struct SchedEntry {
  std::string title;
  std::string short_description;
  std::string description;
  std::string description_trunc;
  std::string start;
  std::string end;
  std::string day;
  std::string epgid;
  bool truncated;
  tState timer;
  int start_row;
  int row_count;

  static SchedEntry DummyEntry(int start_row, int row_count) {
    SchedEntry en;
    en.start_row = start_row;
    en.row_count = row_count;
    // no title and no start time = dummy event
    en.title = "";
    en.start = "";
    return en;
  }
};

std::vector<std::string> times_names;
std::vector<std::string> channel_groups_names;

#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("multischedule");

static const char* rawData = "T\001\000\000V\001\000\000\316\001\000\000\335\001\000\000\344\001\000\000\353\001\000"
  "\000\226\002\000\000\331\002\000\000<\003\000\000w\003\000\000H\004\000\000O\004\000\000m\004\000\000\355\004\000\000"
  ".\005\000\000/\005\000\000[\005\000\000\134\005\000\000]\005\000\000^\005\000\000\236\005\000\000\246\005\000\000\257"
  "\005\000\000\301\005\000\000\330\005\000\000\333\005\000\000\343\005\000\000\344\005\000\000\363\005\000\000\377\005"
  "\000\000\000\006\000\0001\006\000\000x\006\000\000\314\006\000\000\360\006\000\000\001\007\000\000.\007\000\000~\007"
  "\000\000\244\007\000\000\265\007\000\000\330\007\000\000\343\007\000\000,\010\000\000-\010\000\000]\010\000\000i\010"
  "\000\000r\010\000\000z\010\000\000\220\010\000\000\252\010\000\000\262\010\000\000\263\010\000\000\340\010\000\000"
  "\015\t\000\000\024\t\000\000<\t\000\000C\t\000\000o\t\000\000p\t\000\000\243\t\000\000\244\t\000\000\251\t\000\000"
  "\270\t\000\000\331\t\000\000\343\t\000\000\026\n\000\000\027\n\000\000\030\n\000\000v\n\000\000\364\n\000\000\007\013"
  "\000\000\010\013\000\000\016\013\000\000\030\013\000\000=\013\000\000\277\013\000\000\322\013\000\000\323\013\000\000"
  "\331\013\000\000\343\013\000\000\034\014\000\000\037\014\000\000;\014\000\000>\014\000\000\?\014\000\000  \n  <html>"
  "\n    <head>\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n      <title>VDR Live -"
  " </title>\n      \n      \n      \n      <script type=\"text/javascript\"><!--\n      function KeyboardInput(ev) {\n "
  "       if (ev.ctrlKey)\n          switch (ev.which) {\n          case 37: // left\n            \n            return f"
  "alse;\n          case 39: // right\n            \n            return false;\n          }\n          switch (ev.key) {"
  "\n          case '<':\n            \n            return false;\n          case '>':\n            \n            return"
  " false;\n          }\n        return true;\n      }\n      //--></script>\n    </head>\n    <body onload=\"adjustHead"
  "er()\" onresize=\"adjustHeader()\" onkeydown=\"return KeyboardInput(event);\">\n      \n      \n      <div class=\"in"
  "halt\">\n  <table class=\"mschedule\" cellspacing=\"0\" cellpadding=\"0\">\n  <tr class=\" topaligned \">\n  <td > <d"
  "iv class=\"boxheader\"> <div><div></div></div> </div></td>\n  <td class=\"time spacer\"> &nbsp; </td>\n\n    <td> <di"
  "v class=\"boxheader\"> <div> <div>\n\n\n\n</div></div> </div></td>\n<td class=\"time spacer\"> &nbsp; </td>\n  </tr>"
  "\n    <tr>\n\n      <td class=\" time leftcol rightcol \">\n        \n        &nbsp;\n      </td>\n\n      <td class "
  "= \" time spacer \" > &nbsp; </td>\n      <td class=\"bottomrow event topaligned leftcol rightcol\" rowspan=\"\">\n  "
  "          <div class=\" content1 \" >\n            <div class= \"start withmargin\"></div>\n          </div>\n      <"
  "/td>\n      <td class=\" event topaligned leftcol rightcol\" rowspan=\"\">\n          <div class=\" content1 \" >\n  "
  "        <div class= \"start withmargin\"></div>\n          </div>\n        </td>\n      <td class=\" event topaligned"
  " leftcol rightcol \" rowspan=\"\">\n      <div class=\" content1 \" >\n      <div class=\" tools1 \" >\n        \n   "
  "     <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n        <img src=\"img/\" width=\"1"
  "6\" height=\"16\">\n        \n        </div><div class= \"start withmargin\"></div>\n        <div class=\"title withm"
  "argin\"></div>\n          <div class=\"short withmargin\"></div>\n        <div class=\"description withmargin\">\n   "
  "       ...</div><div class=\"more withmargin\"><a ></a>\n        </div>\n        </div></div>\n      </td>\n    </tr>"
  "\n</%cpp\n      </table>\n    </div>\n  </body>\n</html>\n\n\n<form action=\"multischedule.html\" method=\"get\" id="
  "\"channels\">\n  <span>\n  <label for=\"channel\">:&nbsp;<span class=\"bold\"></span></label>\n  <select name=\"chann"
  "el\" id=\"channel\" onchange=\"document.forms.channels.submit()\" >\n    <option value=\"\">\n    </option>\n  </sele"
  "ct>\n  <label for=\"time_para\">:&nbsp;<span class=\"bold\"></span></label>\n  <select name=\"time_para\" id=\"time_p"
  "ara\" onchange=\"document.forms.channels.submit()\" >\n    <option value=\"\">\n    </option>\n  </select>\n  </span>"
  "\n</form>\n<span class=\"sep\">|</span>\n\302\253 \n<span class=\"sep\">|</span>\n \302\273\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
unsigned int time_para = qparam.get< unsigned int >("time_para", ( 0));
  // </%args>

#line 63 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 66 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, channel_group, (0));   // <%request> unsigned int channel_group(0)
  _tnt_ignore_unused<channel_group_type>(channel_group);
#line 67 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, time_selected, (0));   // <%request> unsigned int time_selected(0)
  _tnt_ignore_unused<time_selected_type>(time_selected);
#line 68 "multischedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 69 "multischedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 72 "multischedule.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat<0> targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  pageTitle = tr("MultiSchedule");

#define MAX_DAYS 3
#define MAX_HOURS 8
#define MINUTES_PER_ROW 5
#define CHARACTERS_PER_ROW 30

  std::vector<std::vector<int> > channel_groups_numbers;
  {
// build the groups of channels to display
    std::string channelGroupsGen = LiveSetup().GetChannelGroupsGen();
    channel_groups_names.clear();
    channel_groups_numbers.clear();
    int lastChannel = LiveSetup().GetLastChannel();
    LOCK_CHANNELS_READ;
    if (lastChannel == 0) lastChannel = Channels->MaxNumber();
    if (channelGroupsGen == "individual") {
      std::string channelGroups = LiveSetup().GetChannelGroups();
      for (cSv channelGroup: cSplit(channelGroups, ';')) {
        int cur_group_count = 0;
        channel_groups_names.push_back(std::string() );
        channel_groups_numbers.push_back(std::vector<int>() );
        for (cSv thisChannel: cSplit(channelGroup, ',')) {
          if (cur_group_count++ != 0)
            channel_groups_names.back() += " - ";
          else
            channel_groups_names.back() += cToSvConcat(thisChannel, ": ");
          int channel_no = parse_int<int> (thisChannel);
          if (channel_no == 0) {
            esyslog("live: could not convert '%*.s' into a channel number", (int)thisChannel.length(), thisChannel.data() );
            continue;
          }
          const cChannel* Channel = Channels->GetByNumber(channel_no);
          if (!Channel) {
            esyslog("live: could not find channel no '%*.s'.", (int)thisChannel.length(), thisChannel.data() );
            continue;
          }
          channel_groups_numbers.back().push_back(Channel->Number() );
          channel_groups_names.back() += std::string(Channel->Name() );
        }
      }
    } else if (channelGroupsGen == "flat") {
      channel_groups_names.push_back(tr("All channels"));
      channel_groups_numbers.push_back(std::vector<int>() );
      for (const cChannel *channel = Channels->First(); channel && (channel->Number() <= lastChannel); channel = Channels->Next(channel)) {
        if (checkEpg(channel)) channel_groups_numbers.back().push_back(channel->Number() );
      }
    } else if (channelGroupsGen == "vdr") {
      // channel groups from vdr
      for (const cChannel *channel = Channels->First(); channel && (channel->Number() <= lastChannel); channel = Channels->Next(channel))
      {
        if (channel == Channels->First() ) {
          channel_groups_numbers.push_back(std::vector<int>() );
          if (channel->GroupSep()) channel_groups_names.push_back(channel->Name() );
          else {
            channel_groups_names.push_back(tr("First (unnamed) group"));
            if (checkEpg(channel)) channel_groups_numbers.back().push_back( channel->Number() );
          }
        } else {
          if (channel->GroupSep()) {
            channel_groups_numbers.push_back( std::vector<int>() );
            channel_groups_names.push_back(channel->Name() );
          }
          else if (checkEpg(channel)) channel_groups_numbers.back().push_back(channel->Number() );
        }
      }
    } else {
// 5 channels in each group. for channelGroupsGen == "default" or channelGroupsGen.empty()
      int i = -1;
      for (const cChannel *channel = Channels->First(); channel && (channel->Number() <= lastChannel); channel = Channels->Next(channel))
      {
        if (!checkEpg(channel)) continue;
        if ( (++i % 5) == 0 ) {
          channel_groups_names.push_back(std::string(cToSvConcat(channel->Number(), ": ")));
          channel_groups_numbers.push_back(std::vector<int>() );
        } else
          channel_groups_names.back() += " - ";
        channel_groups_numbers.back().push_back(channel->Number() );
        channel_groups_names.back() += std::string(channel->Name() );
      }
    }
  }

  if ( channel < 0 )
  {
    if (cDevice::CurrentChannel())
    {
      // find group corresponding to current channel
      int curGroup = 0;
      int curChannel = cDevice::CurrentChannel();
      for ( std::vector< std::vector<int> >::iterator grIt = channel_groups_numbers.begin();
            grIt != channel_groups_numbers.end() && channel < 0; ++grIt, ++curGroup )
      {
        for ( std::vector<int>::iterator chIt = (*grIt).begin();
               chIt != (*grIt).end() && channel < 0; ++ chIt )
        {
          if ( *chIt == curChannel ) channel_group = channel = curGroup;
        }
      }
      // if nothing is found, fall back to group 0
      if (channel < 0) channel = 0;
    }
    else
    {
      channel_group = channel;
    }
  }

  if ( channel >= (int)channel_groups_numbers.size() ) channel = 0;
  channel_group = channel;

  std::vector<time_t> times_start;
  {
    // build time list
    times_names.clear();
    times_start.clear();

    // calculate time of midnight (localtime) and convert back to GMT
    time_t now = (time(NULL)/3600)*3600;
    time_t now_local = time(NULL);
    struct tm tm_r;
    if ( localtime_r( &now_local, &tm_r ) == 0 ) {
      std::stringstream builder;
      builder << "cannot represent timestamp " << now_local << " as local time";
      throw std::runtime_error( builder.str() );
    }
    tm_r.tm_hour=0;
    tm_r.tm_min=0;
    tm_r.tm_sec=0;
    time_t midnight = mktime( &tm_r );

    // add four 8h steps per day to the time list
    for (int i=0; i<4*MAX_DAYS ; i++ )
    {
      times_start.push_back( midnight + MAX_HOURS*3600*i );
    }
    std::vector< time_t > offsets;
    for (cSv part: cSplit(LiveSetup().GetTimes(), ';'))
    {
      unsigned int sep = part.find(':');
      if (sep == part.npos)
      {
        esyslog("live: Error parsing time '%*.s'", (int)part.length(), part.data() );
        continue;
      }
      cSv hour = part.substr(0, sep );
      cSv min = part.substr(sep+1, part.npos );
      offsets.push_back( parse_int<time_t>( hour )*60*60 + parse_int<time_t>( min ) *60 );
    };
    // add the time of the favourites to the time list
    for (int i=0; i< MAX_DAYS ; i++ )
    {
      std::vector< time_t >::const_iterator offset = offsets.begin();
      for ( ; offset != offsets.end(); ++offset )
      {
        times_start.push_back( midnight + 24*3600*i + *offset );
      }
    }
    // add now
    times_start.push_back( now );
    // sort the times
    std::sort( times_start.begin(), times_start.end() );
    // delete every time which has already passed
    while ( *times_start.begin()< now )
      times_start.erase(times_start.begin() );

    // build the corresponding names
    for ( std::vector< time_t >::const_iterator start = times_start.begin();
        start != times_start.end(); ++start )
    {
      cToSvConcat times_name;
      times_name.appendDateTime(tr("%A, %x"), *start);
      times_name.concat(' ');
      times_name.appendDateTime(tr("%I:%M %p"), *start);
      times_names.push_back(std::string(times_name));
    }
    // the first time is now
    times_names[0]=tr("Now");

    if ( time_para >= times_names.size() )
      time_para = times_names.size()-1;
    time_selected=time_para;
  }

  if (channel_group > 0)
    prev = cString::sprintf("href=\"multischedule.html?time_para=%i&channel=%i\"", time_selected, channel_group - 1);
  if (channel_group < channel_groups_numbers.size() - 1)
    next = cString::sprintf("href=\"multischedule.html?time_para=%i&channel=%i\"", time_selected, channel_group + 1);
  
  reply.out() << _tntChunks[0]; //   
  // <& pageelems.doc_type ...
  { 
#line 268 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 268 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n  <html>\n    <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n      <title>VDR Live - 
#line 272 "multischedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[2]; // </title>\n      
  // <& pageelems.stylesheets ...
  { 
#line 273 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 273 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n      
  // <& pageelems.ajax_js ...
  { 
#line 274 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 274 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n      
  // <& pageelems.create_html_js ...
  { 
#line 275 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 275 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n      <script type="text/javascript"><!--\n      function KeyboardInput(ev) {\n        if (ev.ctrlKey)\n          switch (ev.which) {\n          case 37: // left\n            
#line 281 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[6]; // \n            return false;\n          case 39: // right\n            
#line 284 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[7]; // \n            return false;\n          }\n          switch (ev.key) {\n          case '<':\n            
#line 289 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[8]; // \n            return false;\n          case '>':\n            
#line 292 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[9]; // \n            return false;\n          }\n        return true;\n      }\n      //--></script>\n    </head>\n    <body onload="adjustHeader()" onresize="adjustHeader()" onkeydown="return KeyboardInput(event);">\n      
  // <& pageelems.logo ...
  { 
#line 300 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 300 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n      
  // <& menu ...
  { 
#line 301 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 301 "multischedule.ecpp"
    _tnt_cq5.add( "active", ("multischedule"));
#line 301 "multischedule.ecpp"
    _tnt_cq5.add( "component", ("multischedule.channel_selection"));
#line 301 "multischedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n      <div class="inhalt">\n  
#line 303 "multischedule.ecpp"

    time_t now = time(NULL);
    if (time_para >= times_start.size() ) time_para = times_start.size()-1;
    time_t sched_start = (times_start[ time_para ]/300)*300;
    time_t max_hours = parse_int<time_t>( LiveSetup().GetScheduleDuration() );
    if (max_hours == 0) {
      esyslog("live: could not convert '%s' into a schedule duration", LiveSetup().GetScheduleDuration().c_str());
      max_hours = 8;
    };
    if (max_hours > 48) max_hours = 48;

    time_t sched_end = sched_start + 60 * 60 * max_hours;
    int sched_end_row = ( sched_end - sched_start ) / 60 / MINUTES_PER_ROW;
    std::vector<std::list<SchedEntry> > table;
    table.reserve(channel_groups_numbers[ channel ].size() );
    std::vector<std::string> channel_names(channel_groups_numbers[ channel ].size() );
    std::vector<tChannelID> channel_IDs(channel_groups_numbers[ channel ].size() );
    if ( channel >= (int)channel_groups_numbers.size() )
      channel = channel_groups_numbers.size()-1;
    for ( unsigned int j = 0; j<channel_groups_numbers[ channel ].size(); j++)
    {
      table.emplace_back();
      int prev_row = -1;
      int chan = channel_groups_numbers[ channel ][ j ];

      cChannel* Channel;
      {
        LOCK_CHANNELS_READ;
        Channel = (cChannel *)Channels->GetByNumber( chan );
      }
      if ( ! Channel )
        continue;
      if ( Channel->GroupSep() || !Channel->Name() || !*Channel->Name() )
        continue;
      channel_names[ j ] = Channel->Name();
      channel_IDs[ j ] = Channel->GetChannelID();

      cSchedule const* Schedule;
      {
        LOCK_SCHEDULES_READ;
        Schedule = Schedules->GetSchedule( Channel );
      }
      if ( ! Schedule )
      {
        // insert dummy event for the entire channel if no EPG data
        table[ j ].push_back( SchedEntry::DummyEntry(0 , sched_end_row));
        prev_row = sched_end_row;
        continue;
      }
      for (const cEvent *Event = Schedule->Events()->First(); Event;
       Event = Schedule->Events()->Next(Event) )
    {
      if (Event->EndTime() <= sched_start )
        continue;
      if (Event->StartTime() >= sched_end )
        continue;

      EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
      if ( prev_row < 0 && Event->StartTime() > sched_start + MINUTES_PER_ROW )
      {
        // insert dummy event at start
        table[ j ].push_back( SchedEntry() );
        SchedEntry &en=table[ j ].back();
        int event_start_row = (Event->StartTime() - sched_start) / 60 / MINUTES_PER_ROW;
        en.start_row = 0;
        en.row_count = event_start_row;
        if ( en.row_count < 1 )
          en.row_count = 1;
        // no title and no start time = dummy event
        en.title = "";
        en.start = "";
        prev_row = en.start_row + en.row_count;
      }
      table[ j ].push_back( SchedEntry() );
      SchedEntry &en=table[j].back();

      en.title = epgEvent->Title();
      en.short_description = epgEvent->ShortDescr();
      en.description = epgEvent->LongDescr();
      en.start = epgEvent->StartTime(tr("%I:%M %p"));
      en.end = epgEvent->EndTime(tr("%I:%M %p"));
      en.day = epgEvent->StartTime(tr("%A, %b %d %Y"));
      en.epgid = EpgEvents::EncodeDomId(Channel->GetChannelID(), Event->EventID());
      const cTimer* timer = LiveTimerManager().GetTimer(Event, Channel);
      if (!timer)
        en.timer = tState::None;
      else if (timer->Recording())
        en.timer = tState::Recording;
      else if (timer->Flags() & tfActive)
        en.timer = tState::Active;
      else
        en.timer = tState::Inactive;

      en.start_row = prev_row > 0 ? prev_row : 0;
      int end_time = Schedule->Events()->Next(Event) ?
        Schedule->Events()->Next(Event)->StartTime() :
        Event->EndTime();
      if (end_time > sched_end)
        end_time = sched_end;
      int next_event_start_row = (end_time - sched_start) / 60 / MINUTES_PER_ROW;
      en.row_count = next_event_start_row - en.start_row;
      if ( en.row_count < 1 )
        en.row_count = 1;
      prev_row = en.start_row + en.row_count;

      // truncate description if too long
      en.truncated=false;
      en.description_trunc=StringWordTruncate( en.description,
                           CHARACTERS_PER_ROW*(en.row_count-2),
                           en.truncated );
    }
    if ( table[ j ].begin() == table[ j ].end() )
    {
      // no entries... create a single dummy entry
      table[ j ].push_back( SchedEntry() );
      SchedEntry &en=table[ j ].back();
      en.start_row = 0;
      en.row_count = sched_end_row;
      // no title and no start time = dummy event
      en.title = "";
      en.start = "";
    }
  }

  reply.out() << _tntChunks[12]; // <table class="mschedule" cellspacing="0" cellpadding="0">\n  <tr class=" topaligned ">\n  <td > <div class="boxheader"> <div><div>
#line 429 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << _tntChunks[13]; // </div></div> </div></td>\n  <td class="time spacer"> &nbsp; </td>\n
  reply.out() << _tntChunks[14]; // \n
#line 432 "multischedule.ecpp"
 for ( unsigned int channel = 0; channel< channel_names.size() ; channel++) {

  reply.out() << _tntChunks[15]; //     <td> <div class="boxheader"> <div> <div>
#line 433 "multischedule.ecpp"
  reply.sout() << ( channel_names[channel] );
  reply.out() << _tntChunks[16]; // \n
#line 434 "multischedule.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 435 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 435 "multischedule.ecpp"
    _tnt_cq6.add( "action", "switch_channel");
#line 435 "multischedule.ecpp"
    _tnt_cq6.add( "alt", "");
#line 435 "multischedule.ecpp"
    _tnt_cq6.add( "image", "zap.png");
#line 435 "multischedule.ecpp"
    _tnt_cq6.add( "param", (channel_IDs[channel]));
#line 435 "multischedule.ecpp"
    _tnt_cq6.add( "tip", (tr("Switch to this channel.")));
#line 435 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[17]; // \n
#line 436 "multischedule.ecpp"
   }

  // <& pageelems.hls_channel ...
  { 
#line 437 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 437 "multischedule.ecpp"
    _tnt_cq7.add( "channelId", (channel_IDs[channel]));
#line 437 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 438 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 438 "multischedule.ecpp"
    _tnt_cq8.add( "channelId", (channel_IDs[channel]));
#line 438 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[19]; // \n</div></div> </div></td>\n<td class="time spacer"> &nbsp; </td>\n
#line 441 "multischedule.ecpp"
 }

  reply.out() << _tntChunks[20]; //   </tr>\n
#line 443 "multischedule.ecpp"

  bool odd=true;
  std::vector<std::list<SchedEntry>::iterator> cur_event;
  cur_event.reserve(table.size() );
  for (size_t i = 0; i < table.size(); i++) cur_event.push_back(table[i].begin());
  for (int row = 0 ; row < sched_end_row; row++ ) {
    int minutes= ( (sched_start +  row * 60 * MINUTES_PER_ROW ) % 3600 ) / 60;
    std::string row_class;
    if (minutes < MINUTES_PER_ROW) odd = !odd; // full hour, swap odd/even
    if ( (sched_start +  row * 60 * MINUTES_PER_ROW) <= now &&
         (sched_start +  (row+1) * 60 * MINUTES_PER_ROW) > now ) row_class +=" current_row ";
    row_class += odd ? " odd " : " even ";

  reply.out() << _tntChunks[21]; //     <tr>\n
  reply.out() << _tntChunks[22]; // \n      <td class="
#line 458 "multischedule.ecpp"
  if ( row == sched_end_row - 1 )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[23]; //  time leftcol rightcol 
#line 458 "multischedule.ecpp"
  reply.sout() << ( row_class );
  reply.out() << _tntChunks[24]; // ">\n
#line 459 "multischedule.ecpp"
   if (minutes < MINUTES_PER_ROW) {

  reply.out() << _tntChunks[25]; //         
#line 460 "multischedule.ecpp"
  reply.sout() << ( cToSvDateTime(tr("%I:%M %p"), sched_start +  row * 60 * MINUTES_PER_ROW)  );
  reply.out() << _tntChunks[26]; // \n
#line 461 "multischedule.ecpp"
   } else {

  reply.out() << _tntChunks[27]; //         &nbsp;\n
#line 463 "multischedule.ecpp"
   }

  reply.out() << _tntChunks[28]; //       </td>\n
  reply.out() << _tntChunks[29]; // \n
#line 466 "multischedule.ecpp"
   for (unsigned int channel = 0; channel < channel_names.size() ; channel++) {

  reply.out() << _tntChunks[30]; //       <td class = " time spacer " > &nbsp; </td>\n
#line 468 "multischedule.ecpp"

      if (cur_event[channel] == table[channel].end()
       || cur_event[channel]->start_row != row )
      {
        // no new event in this channel, skip it
        SchedEntry &en=*(--table[channel].end());
        if (row == 0 || en.start_row + en.row_count == row) {

  reply.out() << _tntChunks[31]; //       <td class="bottomrow event topaligned leftcol rightcol" rowspan="
#line 476 "multischedule.ecpp"
  reply.sout() << ( sched_end_row - row );
  reply.out() << _tntChunks[32]; // ">\n            <div class=" content1 " >\n            <div class= "start withmargin">
#line 478 "multischedule.ecpp"
  if ( row == 0 )
    reply.sout() <<  "No EPG available" ;
#line 478 "multischedule.ecpp"
  if ( row != 0 )
    reply.sout() <<  "EPG end" ;
  reply.out() << _tntChunks[33]; // </div>\n          </div>\n      </td>\n
#line 481 "multischedule.ecpp"

        }
        continue;
      }

      SchedEntry &en=*cur_event[channel];
      if (en.title.empty() && en.start.empty() )
      {
      // empty dummy event

  reply.out() << _tntChunks[34]; //       <td class="
#line 491 "multischedule.ecpp"
  if ( row + en.row_count == sched_end_row )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[35]; //  event topaligned leftcol rightcol" rowspan="
#line 491 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << _tntChunks[36]; // ">\n          <div class=" content1 " >\n          <div class= "start withmargin">
#line 493 "multischedule.ecpp"
  if ( en.row_count == sched_end_row )
    reply.sout() <<  "EPG empty" ;
  reply.out() << _tntChunks[37]; // </div>\n          </div>\n        </td>\n
#line 496 "multischedule.ecpp"

        ++cur_event[channel];
        continue;
      }
      // output an event cell

  reply.out() << _tntChunks[38]; //       <td class="
#line 502 "multischedule.ecpp"
  if ( row + en.row_count == sched_end_row )
    reply.sout() <<  "bottomrow" ;
  reply.out() << _tntChunks[39]; //  event topaligned leftcol rightcol 
#line 502 "multischedule.ecpp"
  reply.sout() << ( en.timer == tState::None ? "" : (en.timer == tState::Inactive ? "has_inactive_timer" : "has_timer") );
  reply.out() << _tntChunks[40]; // " rowspan="
#line 502 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << _tntChunks[41]; // ">\n      <div class=" content1 " >\n      <div class=" tools1 " >\n        
  // <& pageelems.event_timer ...
  { 
#line 505 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 505 "multischedule.ecpp"
    _tnt_cq9.add( "epgid", (en.epgid));
#line 505 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[42]; // \n
#line 506 "multischedule.ecpp"
     if (LiveFeatures<features::epgsearch>().Recent() ) {

  reply.out() << _tntChunks[43]; //         <a href="searchresults.html\?searchplain=
#line 507 "multischedule.ecpp"
  reply.out() << ( cToSvUrlEscaped(en.title) );
  reply.out() << _tntChunks[44]; // "><img src="
#line 507 "multischedule.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[45]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 507 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 507 "multischedule.ecpp"
    _tnt_cq10.add( "text", (tr("Search for repeats.")));
#line 507 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[46]; //  /></a>\n
#line 508 "multischedule.ecpp"
     } else {

  reply.out() << _tntChunks[47]; //         <img src="img/
#line 509 "multischedule.ecpp"
  reply.sout() << ( en.timer == tState::Recording ? "recording_timer.gif" : (en.timer == tState::Active ? "record_timer.png" : "record_inactive_timer.png") );
  reply.out() << _tntChunks[48]; // " width="16" height="16">\n
#line 510 "multischedule.ecpp"
     } if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[49]; //         
  // <& pageelems.imdb_info_href ...
  { 
#line 511 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 511 "multischedule.ecpp"
    _tnt_cq11.add( "title", (en.title));
#line 511 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[50]; // \n
#line 512 "multischedule.ecpp"
     }

  reply.out() << _tntChunks[51]; //         </div><div class= "start withmargin">
#line 513 "multischedule.ecpp"
  reply.sout() << ( en.start );
  reply.out() << _tntChunks[52]; // </div>\n        <div class="title withmargin">
#line 514 "multischedule.ecpp"
  reply.sout() << ( en.title );
  reply.out() << _tntChunks[53]; // </div>\n
#line 515 "multischedule.ecpp"
     if (en.row_count > 2 && !en.short_description.empty() ) {

  reply.out() << _tntChunks[54]; //           <div class="short withmargin">
#line 516 "multischedule.ecpp"
  reply.sout() << ( en.short_description.empty() ? "&nbsp;" : en.short_description );
  reply.out() << _tntChunks[55]; // </div>\n
#line 517 "multischedule.ecpp"
     } if (en.row_count > 3 && ! en.description_trunc.empty() ) {

  reply.out() << _tntChunks[56]; //         <div class="description withmargin">
#line 518 "multischedule.ecpp"
  reply.sout() << (en.description_trunc);
  reply.out() << _tntChunks[57]; // \n
#line 519 "multischedule.ecpp"
       if (en.truncated) {

  reply.out() << _tntChunks[58]; //           ...</div><div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 520 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 520 "multischedule.ecpp"
    _tnt_cq12.add( "text", (tr("Click to view details.")));
#line 520 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 520 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 520 "multischedule.ecpp"
    _tnt_cq13.add( "domId", en.epgid);
#line 520 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[59]; // >
#line 520 "multischedule.ecpp"
  reply.sout() << ( tr("more") );
  reply.out() << _tntChunks[60]; // </a>\n
#line 521 "multischedule.ecpp"
       }

  reply.out() << _tntChunks[61]; //         </div>\n
#line 523 "multischedule.ecpp"
     }

  reply.out() << _tntChunks[62]; //         </div></div>\n      </td>\n
#line 526 "multischedule.ecpp"

      // move to next event for this channel
      ++cur_event[channel];
    }

  reply.out() << _tntChunks[63]; //     </tr>\n
#line 532 "multischedule.ecpp"
 }

  reply.out() << _tntChunks[64]; // </%cpp\n      </table>\n    </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[65]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[66]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 63 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 66 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, channel_group, (0));   // <%request> unsigned int channel_group(0)
  _tnt_ignore_unused<channel_group_type>(channel_group);
#line 67 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, time_selected, (0));   // <%request> unsigned int time_selected(0)
  _tnt_ignore_unused<time_selected_type>(time_selected);
#line 68 "multischedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 69 "multischedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[67]; // <form action="multischedule.html" method="get" id="channels">\n  <span>\n  <label for="channel">
#line 543 "multischedule.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[68]; // :&nbsp;<span class="bold"></span></label>\n  <select name="channel" id="channel" onchange="document.forms.channels.submit()" >\n
#line 545 "multischedule.ecpp"
 for (unsigned int i = 0; i < channel_groups_names.size(); ++i) {

  reply.out() << _tntChunks[69]; //     <option value="
#line 546 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << _tntChunks[70]; // "
#line 546 "multischedule.ecpp"
  if ( i == channel_group )
    reply.out() <<  " selected=\"selected\"" ;
  reply.out() << _tntChunks[71]; // >\n    
#line 547 "multischedule.ecpp"
  reply.sout() << ( channel_groups_names[i] );
  reply.out() << _tntChunks[72]; // </option>\n
#line 548 "multischedule.ecpp"
 }

  reply.out() << _tntChunks[73]; //   </select>\n  <label for="time_para">
#line 550 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << _tntChunks[74]; // :&nbsp;<span class="bold"></span></label>\n  <select name="time_para" id="time_para" onchange="document.forms.channels.submit()" >\n
#line 552 "multischedule.ecpp"
 for (unsigned int i = 0; i < times_names.size(); ++i) {

  reply.out() << _tntChunks[75]; //     <option value="
#line 553 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << _tntChunks[76]; // "
#line 553 "multischedule.ecpp"
  if ( i == time_selected )
    reply.out() <<  " selected=\"selected\"" ;
  reply.out() << _tntChunks[77]; // >\n    
#line 554 "multischedule.ecpp"
  reply.sout() << ( times_names[i] );
  reply.out() << _tntChunks[78]; // </option>\n
#line 555 "multischedule.ecpp"
 }

  reply.out() << _tntChunks[79]; //   </select>\n  </span>\n</form>\n<span class="sep">|</span>\n
#line 560 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "<a " << *prev << ">";
  reply.out() << _tntChunks[80]; // \302\253 
#line 560 "multischedule.ecpp"
  reply.sout() << ( tr("Prev. entry") );
#line 560 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[81]; // \n<span class="sep">|</span>\n
#line 562 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "<a " << *next << ">";
#line 562 "multischedule.ecpp"
  reply.sout() << ( tr("Next entry") );
  reply.out() << _tntChunks[82]; //  \302\273
#line 562 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[83]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
