////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}

std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}
bool getLanguage(std::string &language, const char *env_name) {
  const char *env_language = std::getenv(env_name);
  bool found = env_language && strlen(env_language) >= 2;
  if (found) language.append(env_language, 2);
  return found;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stream_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stream_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    hls_recording_type hls_recording;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    stream_recording_type stream_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\204\006\000\000\205\006\000\000\207\006\000\000\365\006\000\000\366\006\000\000\370\006"
  "\000\000t\007\000\000u\007\000\000\341\007\000\000\255\010\000\000\256\010\000\000\260\010\000\000w\t\000\000\221\t"
  "\000\000\232\t\000\000\247\t\000\000\315\t\000\000\364\t\000\000\365\t\000\000\367\t\000\000\021\n\000\000\022\n\000"
  "\000\024\n\000\000 \n\000\0009\n\000\000=\n\000\000\?\n\000\000M\n\000\000]\n\000\000^\n\000\000`\n\000\000c\n\000"
  "\000g\n\000\000i\n\000\000|\n\000\000\203\n\000\000\205\n\000\000\206\n\000\000\221\n\000\000\230\n\000\000\241\n\000"
  "\000\242\n\000\000\244\n\000\000\316\n\000\000\320\n\000\000\363\n\000\000\365\n\000\000\020\013\000\000\031\013\000"
  "\000!\013\000\000\"\013\000\000$\013\000\000.\013\000\000L\013\000\000Z\013\000\000a\013\000\000j\013\000\000r\013"
  "\000\000s\013\000\000u\013\000\000\177\013\000\000\231\013\000\000\247\013\000\000\256\013\000\000\267\013\000\000"
  "\277\013\000\000\300\013\000\000\302\013\000\000\314\013\000\000\353\013\000\000\002\014\000\000\t\014\000\000\022"
  "\014\000\000\032\014\000\000\033\014\000\000\035\014\000\000&\014\000\000;\014\000\000D\014\000\000H\014\000\000M\014"
  "\000\000N\014\000\000O\014\000\000Q\014\000\000k\014\000\000l\014\000\000{\014\000\000\204\014\000\000\210\014\000"
  "\000\215\014\000\000\216\014\000\000\220\014\000\000\224\014\000\000\225\014\000\000\270\014\000\000\304\014\000\000"
  "\315\014\000\000\325\014\000\000\326\014\000\000\330\014\000\000\373\014\000\000\007\015\000\000\020\015\000\000\030"
  "\015\000\000\032\015\000\000\034\015\000\000t\017\000\000\214\017\000\000\323\017\000\000\335\017\000\000\377\017\000"
  "\000\t\020\000\000.\020\000\000\027\021\000\000\201\021\000\000\202\021\000\000\204\021\000\000\001\022\000\000R\023"
  "\000\000r\023\000\000\330\023\000\000\341\023\000\000\352\023\000\000\363\023\000\000\374\023\000\000;\024\000\000D"
  "\024\000\000v\024\000\000\334\024\000\000\010\025\000\000 \025\000\000!\025\000\000#\025\000\000%\025\000\000&\025"
  "\000\000*\025\000\000+\025\000\000U\025\000\000a\025\000\000j\025\000\000r\025\000\000t\025\000\000w\025\000\000x\025"
  "\000\000|\025\000\000}\025\000\000\302\025\000\000\314\025\000\000\023\026\000\000\027\026\000\000\033\026\000\0006"
  "\026\000\000R\026\000\000T\026\000\000Z\026\000\000p\026\000\000r\026\000\000x\026\000\000\220\026\000\000\223\026"
  "\000\000\303\026\000\000\317\026\000\000\330\026\000\000\340\026\000\000\354\026\000\000\016\027\000\000\021\027\000"
  "\000\027\027\000\000\030\027\000\000\"\027\000\000D\027\000\000G\027\000\000M\027\000\000N\027\000\000X\027\000\000n"
  "\027\000\000q\027\000\000w\027\000\000x\027\000\000\202\027\000\000\203\027\000\000\205\027\000\000\250\027\000\000"
  "\352\027\000\000\013\030\000\000\?\030\000\000D\030\000\000R\030\000\000\212\030\000\000\216\030\000\000\234\030\000"
  "\000\323\030\000\000\330\030\000\000\346\030\000\000\036\031\000\000#\031\000\000/\031\000\000D\031\000\000K\031\000"
  "\000\300\031\000\000'\032\000\000@\032\000\000B\032\000\000Y\032\000\000[\032\000\000c\032\000\000\212\032\000\000"
  "\227\032\000\000\305\032\000\000\346\032\000\000\356\032\000\000\372\032\000\000\373\032\000\000\036\033\000\000%\033"
  "\000\000S\033\000\000w\033\000\000\244\033\000\000\310\033\000\000\350\033\000\000\005\034\000\0009\034\000\000]\034"
  "\000\000u\034\000\000\243\034\000\000\302\034\000\000\332\034\000\000\010\035\000\000'\035\000\000A\035\000\000B\035"
  "\000\000r\035\000\000s\035\000\000\224\035\000\000\246\035\000\000\250\035\000\000\264\035\000\000\306\035\000\000"
  "\342\035\000\000\353\035\000\000\362\035\000\000\016\036\000\000\017\036\000\000\026\036\000\0004\036\000\0006\036"
  "\000\0007\036\000\0008\036\000\000]\036\000\000`\036\000\000g\036\000\000\207\036\000\000\210\036\000\000\213\036\000"
  "\000\222\036\000\000\260\036\000\000\261\036\000\000\270\036\000\000\330\036\000\000\331\036\000\000\340\036\000\000"
  "\n\037\000\000\035\037\000\000#\037\000\000C\037\000\000X\037\000\000\202\037\000\000\226\037\000\000\251\037\000\000"
  "\323\037\000\000\347\037\000\000\372\037\000\000$ \000\0008 \000\000K \000\000Z \000\000v \000\000~ \000\000\205 \000"
  "\000\241 \000\000\250 \000\000\313 \000\000\324 \000\000\333 \000\000\001!\000\000\023!\000\000\036!\000\000:!\000"
  "\000=!\000\000D!\000\000`!\000\000h!\000\000o!\000\000\213!\000\000\220!\000\000\227!\000\000\263!\000\000\264!\000"
  "\000\267!\000\000\276!\000\000\277!\000\000\010\"\000\000\033\"\000\000,\"\000\000-\"\000\000K\"\000\000T\"\000\000["
  "\"\000\000y\"\000\000\201\"\000\000\210\"\000\000\211\"\000\000\247\"\000\000\250\"\000\000\257\"\000\000\315\"\000"
  "\000\326\"\000\000\335\"\000\000\336\"\000\000\374\"\000\000\017#\000\0009#\000\000M#\000\000`#\000\000\216#\000\000"
  "\244#\000\000\271#\000\000\347#\000\000\375#\000\000\022$\000\000\035$\000\000$$\000\0000$\000\000A$\000\000I$\000"
  "\000T$\000\000w$\000\000\247$\000\000\256$\000\000\260$\000\000\330$\000\000\356$\000\000\364$\000\000\006%\000\000"
  "\014%\000\000\025%\000\000\034%\000\000(%\000\000:%\000\000;%\000\000<%\000\000D%\000\000P%\000\000W%\000\000X%\000"
  "\000Z%\000\000\134%\000\000]%\000\000`%\000\000b%\000\000c%\000\000\232%\000\000\233%\000\000\234%\000\000\262%\000"
  "\000\336%\000\000\372%\000\000\374%\000\000{&\000\000\355&\000\000 '\000\000\204'\000\000\361'\000\000\222(\000\000"
  "\372(\000\000`)\000\000\313)\000\000G*\000\000z*\000\000\243*\000\000\312*\000\000\363*\000\000$+\000\000\212+\000"
  "\000\255+\000\000\261+\000\000\275+\000\000\277+\000\000\300+\000\000\314+\000\000\316+\000\000\317+\000\000),\000"
  "\000\235,\000\000\300,\000\000\304,\000\000\320,\000\000\322,\000\000\323,\000\000\337,\000\000\341,\000\000\342,\000"
  "\000<-\000\000\251-\000\000\314-\000\000\320-\000\000\334-\000\000\336-\000\000\337-\000\000\353-\000\000\355-\000"
  "\000\356-\000\000D.\000\000\210.\000\000\2211\000\000\3041\000\000\3032\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//"
  "DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script type=\"text/javascri"
  "pt\" src=\"js/live/createHtml.js\"></script>\n<script type=\"text/javascript\" src=\"js.html\"></script>\n\n<link rel"
  "=\"stylesheet\" type=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n"
  "<link rel=\"stylesheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src=\"js/li"
  "ve/header.js\"></script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-- start "
  "of fixed page header -->\n<div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" s"
  "tyle=\"display: none\"></div>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a"
  " href=\"\">\n<img src=\"\" alt=\"VDR Live!\" class=\"logo\" /></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\n"
  "style=\"visibility: hidden\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\" style=\"width: %\"></div></div>\n"
  "\n\n\n<a id=\"\"  href=\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\" /></a> \n\n\n<a href=\"http://www.imdb.com/f"
  "ind\?s=all&q=\"\n<a href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\"  /></a> \n\n\n<a c"
  "lass=\"\" href=\"stream.html\?channelid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a class=\"\" href=\"stre"
  "am.html\?recid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a class=\"\" href=\"playlist.m3u\?channelid=\" do"
  "wnload><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"\" download><img src=\"\" alt=\"\"  /> </a>\n\n\n\n"
  "\n<a href=\"http://localhost:/.ts\"><img src=\"\" alt=\"\"  /> </a>\n\n\n\n    \n    <a href=\"edit_timer.html\?epgid"
  "=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n  <a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n"
  "\n\n\n  <script type=\"text/javascript\" src=\"js/mootools/mootools.v1.11.js\"></script>\n  <script type=\"text/javas"
  "cript\" src=\"js/live/liveajax.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/infowin.js\"></script"
  ">\n  <script type=\"text/javascript\" src=\"js/live/hinttips.js\"></script>\n  <script type=\"text/javascript\" src="
  "\"js/live/browserwin.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n  <"
  "script type=\"text/javascript\"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          "
  "buttonimg: 'img/transparent.png',\n          loadingMsg: '',\n          errorMsg: ''\n        },\n        notifyStrin"
  "gs: {\n          successMsg: '<img src=\"\" alt=\"\"> ',\n          errorMsg: '<img src=\"\" alt=\"\"> '\n        }\n"
  "      });\n  --></script>\n  <script type=\"text/javascript\" src=\"js/live/vdr_status.js\"></script>\n  <script type"
  "=\"text/javascript\"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n    window.addEvent('domready',"
  " function(){\n      InfoBox.request();\n    });\n    window.addEvent('unload', function(){\n      InfoBox.pageFinishe"
  "d();\n    });\n  --></script>\n\n\n\n<div id=\"infobox\">\n  <div class=\"statuscontent\">\n    <div class=\"st_heade"
  "r\">\n      <div id=\"infobox_caption\" class=\"caption\"></div>\n      <div id=\"infobox_timenow\" class=\"now\">--:"
  "--</div>\n    </div>\n    <div class=\"st_content\">\n      <div id=\"infobox_name\" class=\"name\"></div>\n      <di"
  "v id=\"infobox_duration\" class=\"duration\">--:--</div>\n    </div>\n    <div class=\"st_controls\">\n      <div cla"
  "ss=\"st_update\">\n        <a href=\"javascript:InfoBox.toggleUpdate()\" ><img id=\"statusReloadBtn\" src=\"\" alt=\""
  "\" /></a>\n      </div>\n      <div id=\"infobox_recording_buttons\" style=\"display: none\">\n        \n        \n  "
  "      \n        \n        \n      </div>\n      <div id=\"infobox_channel_buttons\">\n        \n        \n      </div"
  ">\n      <div class=\"st_pbar\">\n        \n      </div>\n    </div>\n  </div>\n  <div style=\"display: none;\">\n   "
  " <span id=\"__infobox_request_err\"></span>\n    <span id=\"__infobox_update_err\"></span>\n  </div>\n</div>\n\n\n\n "
  " \n    \n  <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n  \n  \n    \n<img data-src="
  "\"img/transparent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n          <script class=\"injectIcons\">\n  "
  "        injectHdSdIcon(\"icons-\", \"\", \"\", \"\")\n          </script>\n  <td class=\"action leftcol \"></td>\n   "
  " <td class=\"action \"></td>\n      <td class=\"action \">\n        <a href=\"searchresults.html\?searchplain=\"><img"
  " src=\"\" alt=\"\"  /></a>\n      </td>\n    <td class=\"td-hidden-xs action\">\n      \n    </td>\n    <td class=\"t"
  "d-hidden-xs action\">\n      \n    </td>\n    <td class=\"action \">\n      \n    </td>\n\n\n\n  <div class=\"epg_des"
  "cription\" id=\"\">\n    <div class=\"station\">\n      <div class=\"boxheader\">\n\n<div>\n<div class = \"caption\">"
  "\n  <a id=\"_epg_m\"     class = \"active\"   onclick=\"displayEPG('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inac"
  "tive\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_m\"  class = \"inactive\" onclick=\"displayActors('')\""
  " ></a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\"displayArtwork('')\" ></a>\n</div>\n<div class=\"captio"
  "n\"></div>\n</div>\n                        </div>\n    </div>\n    <div class=\"epg_content\">\n      <div class=\"e"
  "pg_tools\">\n        \n      </div>\n      <div class=\"epg_info\">\n        <div class=\"info\">\n          <div cla"
  "ss=\"duration\">\n            <span title=\"\"></span> / <span title=\"\"></span>\n            <div class=\"progress"
  "\"><div></div></div>\n          </div>\n          <div class=\"time\">\n              <span class=\"bold\"></span>\n "
  "           \n              <div class=\"channel\"></div>\n          </div>\n          <div class=\"title\"></div>\n  "
  "        <div class=\"short\"></div>\n          <div class=\"description\" id=_description>\n          <span id = \"_e"
  "pg_image\" class=\"epg_images\">\n         <a href=\"/epgimages/\" target=\"_blank\">\n            <img src=\"/epgima"
  "ges/\" class=\"epg_image\"/>\n         </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscra"
  "per/\" class=\"epg_image\"/>\n    </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscraper/"
  "\" class=\"epg_image\"/>\n    </a>\n      <a href=\"/recimages//\" target=\"_blank\">\n        <img src=\"/recimages/"
  "/\" class=\"epg_image\"/>\n      </a>\n          </span> \n\n\n<div id = '_scraper' hidden>\n  <div class=\"scraper_l"
  "ist\">         </div>\n  <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\"> SE </div>\n    <div cl"
  "ass=\"scraper_list\">   </div>\n      <div class=\"scraper_list\">  / </div>\n    <div class=\"scraper_list\"> </div>"
  "\n      <div class=\"scraper_list\"> </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n"
  "      <div class=\"scraper_list\"></div>\n      <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n       "
  " <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n   "
  "   <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      </table>\n  <div class=\"sc"
  "raper_list\">        </div>\n  <div class=\"scraper_list\">       </div>\n  <div class=\"scraper_list\">         </di"
  "v>\n  <div class=\"scraper_list\"><a href =\"\" target=\"_blank\"></a></div>\n  <div class=\"scraper_list\">   </div>"
  "\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">     </div>\n  <div class=\"scraper_lis"
  "t\">  / </div>\n\n    <div class=\"scraper_list\">\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\"> "
  " </a>\n    </div>\n\n    <div class=\"scraper_list\">         </div>\n    <div class=\"scraper_list\">        </div>"
  "\n\n    <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\">         </div>\n\n    <div class=\"scra"
  "per_list\"></div>\n    <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>"
  "\n        <tr>\n          <td class=\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n        <tr>\n      "
  "    <td class=\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n  </table>\n</div>\n\n<div id = '_actors' "
  "hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscrap"
  "er/\" alt=\": \" class=\"actor\" />\n      </a>\n    </td>\n      </tr>\n      <tr></tr>\n    </tr>\n    <tr></tr>\n<"
  "/table>\n</div>\n\n<div id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '_epg'>\n \n :\n    : \n        </div>\n  "
  "    </div>\n    </div>\n  </div>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\"_blank\">\n    <img src=\"/tvscraper"
  "/\" class=\"artwork\" />\n  </a>\n\n\n  <div class=\"epg_description\" id=\"aboutBox\">\n    <div class=\"station\">"
  "\n      <div class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n    </div>\n    <div class=\"epg_con"
  "tent\">\n      <div>\n        <div class=\"about_head\"><div><div></div></div></div>\n        <div class=\"about_left"
  "\">:</div>\n        <div class=\"about_right\">Thomas Keil (Thomas)</div>\n        <div class=\"about_left\">:</div>"
  "\n        <div class=\"about_right\">Sascha Volkenandt (LordJaxom)</div>\n        <div class=\"about_left\">:</div>\n"
  "        <div class=\"about_right\">Markus Ehrnsperger (MarkusE @ <a href=\"https://www.vdr-portal.de\">VDR Portal</a>"
  ")</div>\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\">Jasmin Jessich (jasminj)</div>"
  "\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\">Dieter Hametner (tadi)</div>\n       "
  " <div class=\"about_left\">:</div>\n        <div class=\"about_right\">Christian Wieninger (winni)</div>\n        <di"
  "v class=\"about_left\">:</div>\n        <div class=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n        "
  "<div class=\"about_head\"><div><div></div></div></div>\n        <div class=\"about_left\">:</div>\n        <div class"
  "=\"about_right\"></div>\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\"></div>\n      "
  "  <div class=\"about_head\"><div><div></div></div></div>\n        <div class=\"about_left\">EPGsearch:</div>\n       "
  " <div class=\"about_right\">\n          <img align=\"center\" src=\"\"/>\n            : \n            : \n          ("
  "<a href=\"https://github.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n        </div>\n      "
  "  <div class=\"about_left\">Streamdev server:</div>\n        <div class=\"about_right\">\n          <img align=\"cent"
  "er\" src=\"\"/>\n            : \n            : \n          (<a href=\"https://github.com/vdr-projects/vdr-plugin-stre"
  "amdev\" target=\"_blank\"></a>)<br/>\n        </div>\n        <div class=\"about_left\">tvscraper:</div>\n        <di"
  "v class=\"about_right\">\n          <img align=\"center\" src=\"\"/>\n            : \n            : \n          (<a h"
  "ref=\"https://github.com/MarkusEh/vdr-plugin-tvscraper\" target=\"_blank\"></a>)<br/>\n        </div>\n        <div c"
  "lass=\"about_head\"><div><div></div></div></div>\n        <div class=\"about_line\">Movie information provided by <a "
  "target=\"_blank\" href=\"https://www.themoviedb.org/\">TMDB</a>. This product uses the TMDB API but is not endorsed o"
  "r certified by TMDB.</div>\n        <div class=\"about_line\">Information provided by TheTVDB.com. Please consider <a"
  " target=\"_blank\" href=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSei"
  "rIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94"
  "uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWm"
  "H31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them.</a></div>\n        <div class=\"about_head\"><div"
  "><div></div></div></div>\n        <div class=\"about_line\">:<br/>\n          <a target=\"_blank\" href=\"https://git"
  "hub.com/MarkusEh/vdr-plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n        <div "
  "class=\"about_head\"><div><div>&nbsp;</div></div></div>\n      </div>\n    </div>\n  </div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    hls_recording(*this, "hls_recording"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    stream_recording(*this, "stream_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[6]; // \n
  reply.out() << _tntChunks[9]; // \n
  reply.out() << _tntChunks[10]; // \n\n
  reply.out() << _tntChunks[17]; // \n
  reply.out() << _tntChunks[18]; // \n\n
  reply.out() << _tntChunks[20]; // \n
  reply.out() << _tntChunks[21]; // \n\n
  reply.out() << _tntChunks[28]; // \n
  reply.out() << _tntChunks[29]; // \n\n
  reply.out() << _tntChunks[40]; // \n
  reply.out() << _tntChunks[41]; // \n\n
  reply.out() << _tntChunks[49]; // \n
  reply.out() << _tntChunks[50]; // \n\n
  reply.out() << _tntChunks[57]; // \n
  reply.out() << _tntChunks[58]; // \n\n
  reply.out() << _tntChunks[65]; // \n
  reply.out() << _tntChunks[66]; // \n\n
  reply.out() << _tntChunks[73]; // \n
  reply.out() << _tntChunks[74]; // \n\n
  reply.out() << _tntChunks[80]; // \n
  reply.out() << _tntChunks[81]; // \n
  reply.out() << _tntChunks[82]; // \n\n
  reply.out() << _tntChunks[89]; // \n
  reply.out() << _tntChunks[90]; // \n\n
  reply.out() << _tntChunks[97]; // \n
  reply.out() << _tntChunks[98]; // \n\n
  reply.out() << _tntChunks[103]; // \n\n
  reply.out() << _tntChunks[104]; // \n\n
  reply.out() << _tntChunks[114]; // \n
  reply.out() << _tntChunks[115]; // \n\n
  reply.out() << _tntChunks[130]; // \n
  reply.out() << _tntChunks[131]; // \n\n
  reply.out() << _tntChunks[179]; // \n
  reply.out() << _tntChunks[180]; // \n\n
  reply.out() << _tntChunks[361]; // \n
  reply.out() << _tntChunks[362]; // \n
  reply.out() << _tntChunks[366]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script type="text/javascript" src="js.html"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[7]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 65 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[8]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[11]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 79 "pageelems.ecpp"

  if (LiveSetup().GetShowLogo() || LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[12]; // <div class="page_header">\n
#line 83 "pageelems.ecpp"

    if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[13]; // <a href="
#line 86 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[14]; // ">\n<img src="
#line 87 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[15]; // " alt="VDR Live!" class="logo" /></a>\n
#line 88 "pageelems.ecpp"

    }

#line 91 "pageelems.ecpp"
if (LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 91 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 91 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 91 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[16]; // </div>\n<div style="clear: both"></div>\n
#line 94 "pageelems.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 105 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[19]; // style="visibility: hidden"
#line 105 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 116 "pageelems.ecpp"

  std::string cls("__progress");
  if ((duration >= 0) && ((progress < 0) || (duration == 0)))
    cls +="_invisible";

  reply.out() << _tntChunks[22]; // <div class="
#line 121 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[23]; // "><div class="__elapsed" 
#line 121 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[24]; // id="
#line 121 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[25]; // " 
#line 121 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[26]; // style="width: 
#line 121 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[27]; // %"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 135 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[30]; // <a 
#line 135 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[31]; // id="
#line 135 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[32]; // " 
#line 135 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 135 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 135 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 135 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[33]; //  href="vdr_request/
#line 135 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[34]; // \?param=
#line 135 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[35]; // " 
#line 135 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 135 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 135 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 135 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[36]; //  
#line 135 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[37]; // ><img src="
#line 135 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[38]; // " alt="
#line 135 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[39]; // " /></a> 
#line 135 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 145 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[42]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 149 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?cToSvUrlEscaped(cSv(title).substr(1)):cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[43]; // "\n
#line 150 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[44]; // <a href="http://www.imdb.com/title/
#line 151 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[45]; // "\n
#line 152 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[46]; //  target="_blank"><img src="
#line 153 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[47]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 153 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 153 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 153 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[48]; //  /></a> 
#line 153 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 163 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[51]; // <a class="
#line 166 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[52]; // " href="stream.html\?channelid=
#line 166 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[53]; // "><img class="
#line 166 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[54]; // " src="
#line 166 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[55]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 166 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 166 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 166 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[56]; //  /></a>\n
#line 167 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recId = qparam.get< std::string >("recId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 179 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[59]; // <a class="
#line 182 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[60]; // " href="stream.html\?recid=
#line 182 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[61]; // "><img class="
#line 182 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[62]; // " src="
#line 182 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[63]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 182 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 182 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this recording into browser.")));
#line 182 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[64]; //  /></a>\n
#line 183 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 195 "pageelems.ecpp"

if (LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[67]; // <a class="
#line 198 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[68]; // " href="playlist.m3u\?channelid=
#line 198 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[69]; // " download><img class="
#line 198 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[70]; // " src="
#line 198 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[71]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 198 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 198 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 198 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[72]; //  /></a>\n
#line 199 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 211 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
// <a href="intent://my.example.com:8080/test.mp4#Intent;scheme=http;package=org.videolan.vlc;end">OPEN IN VLC</a>

// std::string server = request.getHost();
// server = server.substr(0, server.rfind(':'));
// cToSvConcat url("intent://", server, ":", LiveSetup().GetServerPort(), "/recstream.html?recid=", recid, "#Intent;scheme=http;package=org.videolan.vlc;end");

cToSvConcat url("playlist.m3u?recid=", recid);
{

  reply.out() << _tntChunks[75]; // <a href="
#line 221 "pageelems.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[76]; // " download><img src="
#line 221 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[77]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 221 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 221 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 221 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[78]; //  /> 
#line 221 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[79]; // </a>\n
#line 222 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stream_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stream_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 236 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{
const cRecording* recording = nullptr;
if (!recid.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(recid);
cToSvConcat rfid;
if (recording) {
  struct stat st;
  if (stat(recording->FileName(), &st) == 0)
    rfid.appendFormated("%lu:%llu.rec", (unsigned long) st.st_dev, (unsigned long long) st.st_ino);
}
if (!rfid.empty() ) {

  reply.out() << _tntChunks[83]; // <a href="http://localhost:
#line 248 "pageelems.ecpp"
  reply.sout() << (cToSvConcat(LiveSetup().GetStreamdevPort()));
  reply.out() << _tntChunks[84]; // /
#line 248 "pageelems.ecpp"
  reply.sout() << (rfid);
  reply.out() << _tntChunks[85]; // .ts"><img src="
#line 248 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[86]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 248 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 248 "pageelems.ecpp"
    _tnt_cq8.add( "text", (tr("Stream this recording.")));
#line 248 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[87]; //  /> 
#line 248 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[88]; // </a>\n
#line 249 "pageelems.ecpp"

}
}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 262 "pageelems.ecpp"

  tChannelID channelid;
  tEventID eventid;
  EpgEvents::DecodeDomId(epgid, channelid, eventid);
  const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
  if (timer) {

  reply.out() << _tntChunks[91]; //     
  // <& pageelems.edit_timer ...
  { 
#line 269 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 269 "pageelems.ecpp"
    _tnt_cq9.add( "imgName", (timer->Recording() ? "recording_timer.gif" : (timer->Flags() & tfActive ? "record_timer.png" : "record_inactive_timer.png")));
#line 269 "pageelems.ecpp"
    _tnt_cq9.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 269 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[92]; // \n
#line 270 "pageelems.ecpp"

  }
  else {

  reply.out() << _tntChunks[93]; //     <a href="edit_timer.html\?epgid=
#line 274 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[94]; // "><img src="
#line 274 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[95]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 274 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 274 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Record this")));
#line 274 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[96]; //  /></a>\n
#line 275 "pageelems.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[99]; //   <a href="edit_timer.html\?timerid=
#line 287 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[100]; // "><img src="
#line 287 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[101]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 287 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 287 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Edit timer")));
#line 287 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[102]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[105]; //   <script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n  <script type="text/javascript" src="js/live/liveajax.js"></script>\n  <script type="text/javascript" src="js/live/infowin.js"></script>\n  <script type="text/javascript" src="js/live/hinttips.js"></script>\n  <script type="text/javascript" src="js/live/browserwin.js"></script>\n  <script type="text/javascript" src="js/live/pageenhance.js"></script>\n  <script type="text/javascript"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          buttonimg: 'img/transparent.png',\n          loadingMsg: '
#line 304 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[106]; // ',\n          errorMsg: '
#line 305 "pageelems.ecpp"
  reply.sout() << ( tr("an error occurred!") );
  reply.out() << _tntChunks[107]; // '\n        },\n        notifyStrings: {\n          successMsg: '<img src="
#line 308 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[108]; // " alt=""> 
#line 308 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[109]; // ',\n          errorMsg: '<img src="
#line 309 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[110]; // " alt=""> 
#line 309 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[111]; // '\n        }\n      });\n  --></script>\n
#line 313 "pageelems.ecpp"

    if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[112]; //   <script type="text/javascript" src="js/live/vdr_status.js"></script>\n  <script type="text/javascript"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n    window.addEvent('domready', function(){\n      InfoBox.request(
#line 320 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[113]; // );\n    });\n    window.addEvent('unload', function(){\n      InfoBox.pageFinished();\n    });\n  --></script>\n
#line 326 "pageelems.ecpp"

    }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[116]; // <div id="infobox">\n  <div class="statuscontent">\n    <div class="st_header">\n      <div id="infobox_caption" class="caption">
#line 337 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[117]; // </div>\n      <div id="infobox_timenow" class="now">--:--</div>\n    </div>\n    <div class="st_content">\n      <div id="infobox_name" class="name"></div>\n      <div id="infobox_duration" class="duration">--:--</div>\n    </div>\n    <div class="st_controls">\n      <div class="st_update">\n        <a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 346 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 346 "pageelems.ecpp"
    _tnt_cq12.add( "text", (tr("Toggle updates on/off.")));
#line 346 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[118]; // ><img id="statusReloadBtn" src="
#line 346 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[119]; // " alt="" /></a>\n      </div>\n      <div id="infobox_recording_buttons" style="display: none">\n        
  // <& ajax_action_href ...
  { 
#line 349 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 349 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("stop_recording"));
#line 349 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_stop"));
#line 349 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("stop.png"));
#line 349 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("stop playback")));
#line 349 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[120]; // \n        
  // <& ajax_action_href ...
  { 
#line 350 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 350 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("play_recording"));
#line 350 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_play"));
#line 350 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("play.png"));
#line 350 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("resume playback")));
#line 350 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[121]; // \n        
  // <& ajax_action_href ...
  { 
#line 351 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 351 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("pause_recording"));
#line 351 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_pause"));
#line 351 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("pause.png"));
#line 351 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("pause playback")));
#line 351 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[122]; // \n        
  // <& ajax_action_href ...
  { 
#line 352 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 352 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("rwd_recording"));
#line 352 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_rwd"));
#line 352 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("rwd.png"));
#line 352 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast rewind")));
#line 352 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[123]; // \n        
  // <& ajax_action_href ...
  { 
#line 353 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 353 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("ffw_recording"));
#line 353 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_ffw"));
#line 353 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("ffw.png"));
#line 353 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("fast forward")));
#line 353 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[124]; // \n      </div>\n      <div id="infobox_channel_buttons">\n        
  // <& ajax_action_href ...
  { 
#line 356 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 356 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 356 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_prevchan"));
#line 356 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_downarrow.png"));
#line 356 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("previous channel")));
#line 356 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[125]; // \n        
  // <& ajax_action_href ...
  { 
#line 357 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 357 "pageelems.ecpp"
    _tnt_cq19.add( "action", ("switch_channel"));
#line 357 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_nextchan"));
#line 357 "pageelems.ecpp"
    _tnt_cq19.add( "image", ("one_uparrow.png"));
#line 357 "pageelems.ecpp"
    _tnt_cq19.add( "tip", (tr("next channel")));
#line 357 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[126]; // \n      </div>\n      <div class="st_pbar">\n        
  // <& progressbar ...
  { 
#line 360 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 360 "pageelems.ecpp"
    _tnt_cq20.add( "id", ("infobox_elapsed"));
#line 360 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[127]; // \n      </div>\n    </div>\n  </div>\n  <div style="display: none;">\n    <span id="__infobox_request_err">
#line 365 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[128]; // </span>\n    <span id="__infobox_update_err">
#line 366 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[129]; // </span>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 383 "pageelems.ecpp"

  int duration = EpgEvents::Duration(startTime, endTime);
  int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
  tChannelID channelId = tChannelID();

  EpgEvents::DecodeDomId(epgid, channelId, eventId);
  if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[132]; //   
  // <& pageelems.event_timer ...
  { 
#line 392 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 392 "pageelems.ecpp"
    _tnt_cq21.add( "epgid", (epgid));
#line 392 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[133]; // \n
#line 393 "pageelems.ecpp"

  if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[134]; //     
  // <& pageelems.ajax_action_href ...
  { 
#line 396 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 396 "pageelems.ecpp"
    _tnt_cq22.add( "action", "switch_channel");
#line 396 "pageelems.ecpp"
    _tnt_cq22.add( "alt", "");
#line 396 "pageelems.ecpp"
    _tnt_cq22.add( "image", "zap.png");
#line 396 "pageelems.ecpp"
    _tnt_cq22.add( "param", (channelId));
#line 396 "pageelems.ecpp"
    _tnt_cq22.add( "tip", (tr("Switch to this channel.")));
#line 396 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n
#line 397 "pageelems.ecpp"

  } if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[136]; //   <a href="searchresults.html\?searchplain=
#line 400 "pageelems.ecpp"
  reply.out() << ( cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[137]; // "><img src="
#line 400 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[138]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 400 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 400 "pageelems.ecpp"
    _tnt_cq23.add( "text", (tr("Search for repeats.")));
#line 400 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[139]; //  /></a>\n
#line 401 "pageelems.ecpp"

    }
    if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[140]; //   
  // <& pageelems.hls_channel ...
  { 
#line 405 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 405 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 405 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n  
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 406 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 406 "pageelems.ecpp"
    _tnt_cq25.add( "channelId", (channelId));
#line 406 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n
#line 407 "pageelems.ecpp"

    }
  if (eventId != 0) {
    /* Need to lock here channels also, because CreateEpgInfo will lock
     * it also and this will result in a wrong lock order */
    LOCK_CHANNELS_READ;
    LOCK_SCHEDULES_READ;
    EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
    const cEvent* event = epgEvent->Event();
    const cChannel* channel = event?Channels->GetByChannelID(event->ChannelID()):nullptr;
    cGetScraperVideo getScraperVideo(event, NULL);
    bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginTvscraper());
    if (scraperDataAvailable) {
      int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
      const char *sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": video_SD_HD == 2 ? "ud" : 0;


  reply.out() << _tntChunks[143]; //     
  // <& pageelems.imdb_info_href ...
  { 
#line 424 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 424 "pageelems.ecpp"
    _tnt_cq26.add( "s_IMDB_ID", (s_IMDB_ID));
#line 424 "pageelems.ecpp"
    _tnt_cq26.add( "title", (title));
#line 424 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n
#line 425 "pageelems.ecpp"
 if (detail > 1) {

  reply.out() << _tntChunks[145]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 427 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[146]; // "></span>\n
#line 428 "pageelems.ecpp"
 if (sdhd) { 
  reply.out() << _tntChunks[147]; //           <script class="injectIcons">\n          injectHdSdIcon("icons-
#line 430 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[148]; // ", "
#line 430 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[149]; // ", "
#line 430 "pageelems.ecpp"
  reply.sout() << ((channel&&channel->Name())?channel->Name():"");
  reply.out() << _tntChunks[150]; // ", "")\n          </script>\n
#line 432 "pageelems.ecpp"

        }
      }
    }
    }
  }
  else { // table output

  reply.out() << _tntChunks[151]; //   <td class="action leftcol 
#line 440 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[152]; // ">
  // <& pageelems.event_timer ...
  { 
#line 440 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 440 "pageelems.ecpp"
    _tnt_cq27.add( "epgid", (epgid));
#line 440 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[153]; // </td>\n
#line 441 "pageelems.ecpp"
 if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[154]; //     <td class="action 
#line 442 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[155]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 442 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 442 "pageelems.ecpp"
    _tnt_cq28.add( "action", "switch_channel");
#line 442 "pageelems.ecpp"
    _tnt_cq28.add( "alt", "");
#line 442 "pageelems.ecpp"
    _tnt_cq28.add( "image", "zap.png");
#line 442 "pageelems.ecpp"
    _tnt_cq28.add( "param", (channelId));
#line 442 "pageelems.ecpp"
    _tnt_cq28.add( "tip", (tr("Switch to this channel.")));
#line 442 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[156]; // </td>\n
#line 443 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) {

  reply.out() << _tntChunks[157]; //       <td class="action 
#line 444 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[158]; // ">\n
#line 445 "pageelems.ecpp"
     if (eventId) {

  reply.out() << _tntChunks[159]; //         <a href="searchresults.html\?searchplain=
#line 446 "pageelems.ecpp"
  reply.out() << ( cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[160]; // "><img src="
#line 446 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[161]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 446 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 446 "pageelems.ecpp"
    _tnt_cq29.add( "text", (tr("Search for repeats.")));
#line 446 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq29);
    // &>
  }
  reply.out() << _tntChunks[162]; //  /></a>\n
#line 447 "pageelems.ecpp"
     }

  reply.out() << _tntChunks[163]; //       </td>\n
#line 449 "pageelems.ecpp"
 } if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded() ) {

  reply.out() << _tntChunks[164]; //     <td class="td-hidden-xs action
#line 450 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  " bottomrow";
  reply.out() << _tntChunks[165]; // ">\n
#line 451 "pageelems.ecpp"
   if ((duration == 0) || (elapsed > 0)) {

  reply.out() << _tntChunks[166]; //       
  // <& pageelems.hls_channel ...
  { 
#line 452 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 452 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 452 "pageelems.ecpp"
    _tnt_cq30.add( "class_", ("hidden-xs"));
#line 452 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq30);
    // &>
  }
  reply.out() << _tntChunks[167]; // \n
#line 453 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[168]; //     </td>\n
#line 455 "pageelems.ecpp"
 } if (LiveFeatures<features::streamdev_server>().Loaded() ) {

  reply.out() << _tntChunks[169]; //     <td class="td-hidden-xs action
#line 456 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  " bottomrow";
  reply.out() << _tntChunks[170]; // ">\n
#line 457 "pageelems.ecpp"
   if ((duration == 0) || (elapsed > 0)) {

  reply.out() << _tntChunks[171]; //       
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 458 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 458 "pageelems.ecpp"
    _tnt_cq31.add( "channelId", (channelId));
#line 458 "pageelems.ecpp"
    _tnt_cq31.add( "class_", ("hidden-xs"));
#line 458 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[172]; // \n
#line 459 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[173]; //     </td>\n
#line 461 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[174]; //     <td class="action 
#line 462 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[175]; // ">\n
#line 463 "pageelems.ecpp"
   if (eventId != 0) {

  reply.out() << _tntChunks[176]; //       
  // <& pageelems.imdb_info_href ...
  { 
#line 464 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 464 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (s_IMDB_ID));
#line 464 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 464 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[177]; // \n
#line 465 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[178]; //     </td>\n
#line 467 "pageelems.ecpp"
} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[181]; //   <div class="epg_description" id="
#line 494 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[182]; // ">\n    <div class="station">\n      <div class="boxheader">\n\n<div>\n
#line 499 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent;
if (iepgEvent) epgEvent = *static_cast<EpgInfoPtr*>((void *)iepgEvent);


sScraperMovieOrTv scraperMovieOrTv;
cGetScraperVideo getScraperVideo(static_cast<cEvent *>((void *)ievent), static_cast<cRecording *>((void *)irecording));
scraperMovieOrTv.found = getScraperVideo.call(LiveSetup().GetPluginTvscraper());
if (scraperMovieOrTv.found) {
  tvType type = getScraperVideo.m_scraperVideo->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = getScraperVideo.m_scraperVideo->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}
std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = getScraperVideo.m_scraperVideo->getCharacters(false);
  scraperMovieOrTv.posters = getScraperVideo.m_scraperVideo->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = getScraperVideo.m_scraperVideo->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = getScraperVideo.m_scraperVideo->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = getScraperVideo.m_scraperVideo->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = getScraperVideo.m_scraperVideo->getEpisodeNumber();
    scraperMovieOrTv.episode.season = getScraperVideo.m_scraperVideo->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[183]; // <div class = "caption">\n  <a id="
#line 587 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[184]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 587 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[185]; // ')" >
#line 587 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[186]; // </a>\n| <a id="
#line 588 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[187]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 588 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[188]; // ')">
#line 588 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[189]; // </a>\n| <a id="
#line 589 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[190]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 589 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[191]; // ')" >
#line 589 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[192]; // </a>\n| <a id="
#line 590 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[193]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 590 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[194]; // ')" >
#line 590 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[195]; // </a>\n</div>\n
#line 592 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[196]; // <div class="caption">
#line 595 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[197]; // </div>\n
#line 596 "pageelems.ecpp"

}

  reply.out() << _tntChunks[198]; // </div>\n                        </div>\n    </div>\n    <div class="epg_content">\n      <div class="epg_tools">\n        
  // <& (tools_comp) ...
  { 
#line 604 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "archived", (archived));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "detail", (2));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "filter", (filter));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "flat", (flat));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "history_num_back", (history_num_back));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "id", (boxId));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "sort", (sort));
#line 604 "pageelems.ecpp"
    _tnt_cq33.add( "title", (title));
#line 604 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[199]; // \n      </div>\n      <div class="epg_info">\n        <div class="info">\n          <div class="duration">\n
#line 609 "pageelems.ecpp"

if (epgEvent && epgEvent->EventDuration() >= 0) {  // recording

  reply.out() << _tntChunks[200]; //             <span title="
#line 612 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[201]; // ">
#line 612 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[202]; // </span> / <span title="
#line 612 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[203]; // ">
#line 612 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[204]; // </span>\n
#line 613 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[205]; //             <div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 617 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 617 "pageelems.ecpp"
    _tnt_cq34.add( "progress", (elapsed));
#line 617 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[206]; // </div></div>\n
#line 618 "pageelems.ecpp"

}

  reply.out() << _tntChunks[207]; //           </div>\n          <div class="time">\n
#line 623 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[208]; //               <span class="bold">
#line 624 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[209]; // </span>\n
#line 625 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[210]; //             
#line 626 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[211]; // \n
#line 627 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[212]; //               <div class="channel">
#line 628 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[213]; // </div>\n
#line 629 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[214]; //           </div>\n          <div class="title">
#line 631 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[215]; // </div>\n          <div class="short">
#line 632 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[216]; // </div>\n          <div class="description" id=
#line 633 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[217]; // _description>\n          <span id = "
#line 634 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[218]; // _epg_image" class="epg_images">\n
#line 635 "pageelems.ecpp"

  std::list<std::string> images = EpgEvents::EpgImages(boxId);
  for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[219]; //          <a href="/epgimages/
#line 639 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[220]; // " target="_blank">\n            <img src="/epgimages/
#line 640 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[221]; // " class="epg_image"/>\n         </a>\n
#line 642 "pageelems.ecpp"
 } bool scraperImage = false;

#line 643 "pageelems.ecpp"
 if(!epgImage.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[222]; //     <a href="/tvscraper/
#line 644 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[223]; // " target="_blank">\n      <img src="/tvscraper/
#line 645 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[224]; // " class="epg_image"/>\n    </a>\n
#line 647 "pageelems.ecpp"
 } if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[225]; //     <a href="/tvscraper/
#line 648 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[226]; // " target="_blank">\n      <img src="/tvscraper/
#line 649 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[227]; // " class="epg_image"/>\n    </a>\n
#line 651 "pageelems.ecpp"

  }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
  if (!scraperImage) {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[228]; //       <a href="/recimages/
#line 660 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[229]; // /
#line 660 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[230]; // " target="_blank">\n        <img src="/recimages/
#line 661 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[231]; // /
#line 661 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[232]; // " class="epg_image"/>\n      </a>\n
#line 663 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[233]; //           </span> 
  reply.out() << _tntChunks[234]; // \n\n
  reply.out() << _tntChunks[235]; // \n<div id = '
#line 670 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[236]; // _scraper' hidden>\n
#line 671 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[237]; //   <div class="scraper_list">
#line 674 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[238]; //          
#line 674 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[239]; // </div>\n
#line 675 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[240]; //   <div class="scraper_list">
#line 678 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[241]; //  
#line 678 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[242]; // </div>\n
#line 679 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[243]; //     <div class="scraper_list">
#line 683 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[244]; //  S
#line 683 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.season )) );
  reply.out() << _tntChunks[245]; // E
#line 683 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.number)) );
#line 683 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?concat("A", cToSvInt(scraperMovieOrTv.episode.absoluteNumber)):"");
  reply.out() << _tntChunks[246]; //  
#line 683 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.name );
  reply.out() << _tntChunks[247]; // </div>\n    <div class="scraper_list">
#line 684 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[248]; //    
#line 684 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[249]; // </div>\n
#line 685 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[250]; //       <div class="scraper_list">
#line 688 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[251]; //  
#line 688 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average) );
  reply.out() << _tntChunks[252]; //  / 
#line 688 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[253]; // </div>\n
#line 689 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[254]; //     <div class="scraper_list">
#line 692 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[255]; //  
#line 692 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[256]; // </div>\n
#line 693 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[257]; //       <div class="scraper_list">
#line 694 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[258]; //  
#line 694 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.episode.runtime*60) );
  reply.out() << _tntChunks[259]; // </div>\n
#line 695 "pageelems.ecpp"
   }

#line 696 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[260]; //       <a href="https://www.imdb.com/title/
#line 697 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[261]; // " target="_blank"> 
#line 697 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[262]; //  </a>\n
#line 698 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[263]; //       <div class="scraper_list">
#line 707 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[264]; // </div>\n      <table>\n
#line 709 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 710 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[265]; //       <tr>\n        <td class="cast_role"> 
#line 712 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[266]; //  </td>\n        <td> 
#line 713 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[267]; //  </td>\n      </tr>\n
#line 715 "pageelems.ecpp"
   }

#line 716 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 717 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[268]; //       <tr>\n        <td class="cast_role"> 
#line 719 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[269]; //  </td>\n        <td> 
#line 720 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[270]; //  </td>\n      </tr>\n
#line 722 "pageelems.ecpp"
   }

#line 723 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 724 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[271]; //       <tr>\n        <td class="cast_role"> 
#line 726 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[272]; //  </td>\n        <td> 
#line 727 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[273]; //  </td>\n      </tr>\n
#line 729 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[274]; //       </table>\n
#line 731 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[275]; //   <div class="scraper_list">
#line 736 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[276]; //         
#line 736 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[277]; // </div>\n
#line 737 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[278]; //   <div class="scraper_list">
#line 738 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[279]; //        
#line 738 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[280]; // </div>\n  <div class="scraper_list">
#line 739 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[281]; //          
#line 739 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[282]; // </div>\n
#line 740 "pageelems.ecpp"
 if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[283]; //   <div class="scraper_list"><a href ="
#line 741 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[284]; // " target="_blank">
#line 741 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[285]; // </a></div>\n
#line 742 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[286]; //   <div class="scraper_list">
#line 743 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[287]; //    
#line 743 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[288]; // </div>\n
#line 744 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[289]; //   <div class="scraper_list">
#line 745 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[290]; //         
#line 745 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.runtime*60) );
  reply.out() << _tntChunks[291]; // </div>\n
#line 746 "pageelems.ecpp"
 }

#line 747 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[292]; //   <div class="scraper_list">
#line 750 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[293]; //      
#line 750 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[294]; // </div>\n
#line 751 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[295]; //   <div class="scraper_list">
#line 755 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[296]; //  
#line 755 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[297]; //  / 
#line 755 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount) );
  reply.out() << _tntChunks[298]; // </div>\n
#line 756 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[299]; // \n
#line 762 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[300]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 764 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[301]; // " target="_blank"> 
#line 764 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[302]; //  </a>\n    </div>\n
#line 766 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[303]; // \n
#line 771 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[304]; //     <div class="scraper_list">
#line 775 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[305]; //          
#line 775 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[306]; // </div>\n
#line 776 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[307]; //     <div class="scraper_list">
#line 780 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[308]; //         
#line 780 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[309]; // </div>\n
#line 781 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[310]; // \n
#line 787 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[311]; //     <div class="scraper_list">
#line 790 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[312]; //  
#line 790 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[313]; // </div>\n
#line 791 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[314]; //     <div class="scraper_list">
#line 795 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[315]; //          
#line 795 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[316]; // </div>\n
  reply.out() << _tntChunks[317]; // \n
#line 799 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[318]; //     <div class="scraper_list">
#line 811 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[319]; // </div>\n    <table>\n
#line 813 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 814 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[320]; //       <tr>\n        <td class="cast_role"> 
#line 816 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[321]; //  </td>\n        <td> 
#line 817 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[322]; //  </td>\n      </tr>\n
#line 819 "pageelems.ecpp"
   }

#line 820 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 821 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 822 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[323]; //         <tr>\n          <td class="cast_role"> 
#line 824 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[324]; //  </td>\n          <td> 
#line 825 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[325]; //  </td>\n        </tr>\n
#line 827 "pageelems.ecpp"
     }

#line 828 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 829 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[326]; //         <tr>\n          <td class="cast_role"> 
#line 831 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[327]; //  </td>\n          <td> 
#line 832 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[328]; //  </td>\n        </tr>\n
#line 834 "pageelems.ecpp"
     }

#line 835 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[329]; //   </table>\n
#line 837 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[330]; // </div>\n
  reply.out() << _tntChunks[331]; // \n<div id = '
#line 843 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[332]; // _actors' hidden>\n
#line 844 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[333]; // <table>\n
#line 848 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string loc_name;
  getLanguage(loc_name, "LANGUAGE") ||
  getLanguage(loc_name, "LC_ALL") ||
  getLanguage(loc_name, "LC_MESSAGES") ||
  getLanguage(loc_name, "LANG");
  if (loc_name.empty() ) {
    loc_name = std::locale("").name().substr(0,2);
    if (loc_name.length() != 2 || loc_name[0] == 'C' || loc_name[0] == '*' || loc_name[0] == 'L') loc_name = "en"; //  use en as default
  }
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[334]; //       <tr>\n
#line 867 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[335]; //     <td>\n      <a href="/tvscraper/
#line 869 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[336]; // " target="_blank">\n        <img src="/tvscraper/
#line 870 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[337]; // " alt="
#line 870 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[338]; // : 
#line 870 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[339]; // " class="actor" />\n      </a>\n    </td>\n
#line 873 "pageelems.ecpp"

    stringAppend(actor_names, "<td><a href=\"https://", loc_name, ".wikipedia.org/wiki/",
      cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")), "\" target=\"_blank\">",
      character->getPersonName(), "</a>");
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[340]; //       </tr>\n      <tr>
#line 883 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[341]; // </tr>\n
#line 884 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[342]; //     </tr>\n    <tr>
#line 893 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[343]; // </tr>\n
#line 894 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[344]; // </table>\n
#line 898 "pageelems.ecpp"

}

  reply.out() << _tntChunks[345]; // </div>\n
  reply.out() << _tntChunks[346]; // \n<div id = '
#line 903 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[347]; // _artwork' hidden>\n
#line 904 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 909 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 909 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_p));
#line 909 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[348]; // \n
  // <& media ...
  { 
#line 910 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 910 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_f));
#line 910 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[349]; // \n
  // <& media ...
  { 
#line 911 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq37;
#line 911 "pageelems.ecpp"
    _tnt_cq37.add( "media_p", (media_b));
#line 911 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq37);
    // &>
  }
  reply.out() << _tntChunks[350]; // \n</div>\n
  reply.out() << _tntChunks[351]; // \n<div id = '
#line 914 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[352]; // _epg'>\n
#line 915 "pageelems.ecpp"

{
  cToSvConcat long_descr_html_esc;
  AppendHtmlEscapedAndCorrectNonUTF8(long_descr_html_esc, long_descr);
  reply.out() << long_descr_html_esc;
}
const char *br_after_long_desc = "<br><br>";
if (long_descr.empty()) br_after_long_desc = "";
const cEvent *event = nullptr;
if (ievent) event = static_cast<cEvent *>((void *)ievent);
else if (irecording) {
  cRecording *recording = static_cast<cRecording *>((void *)irecording);
  if (recording->Info()) event = recording->Info()->GetEvent();
}

if (event) {
  bool first = true;
  for (int i = 0; event->Contents(i); i++) {
    const char *s = event->ContentToString(event->Contents(i));
    if (!isempty(s)) {
      if (first) {
        first = false;

  reply.out() << _tntChunks[353]; //  
#line 938 "pageelems.ecpp"
  reply.out() << (br_after_long_desc);
  reply.out() << _tntChunks[354]; // \n 
#line 939 "pageelems.ecpp"
  reply.sout() << (tr("Content"));
  reply.out() << _tntChunks[355]; // :\n
#line 940 "pageelems.ecpp"
     } else { reply.out() << ","; }

  reply.out() << _tntChunks[356]; //  
#line 941 "pageelems.ecpp"
  reply.sout() << (s);
#line 941 "pageelems.ecpp"

    }
  }
  if (event->ParentalRating()) {
    if (first) reply.out() << br_after_long_desc;
    else reply.out() << "<br>";

  reply.out() << _tntChunks[357]; //    
#line 948 "pageelems.ecpp"
  reply.sout() << (tr("Parental rating"));
  reply.out() << _tntChunks[358]; // : 
#line 948 "pageelems.ecpp"
  reply.sout() << (*event->GetParentalRatingString());
  reply.out() << _tntChunks[359]; // \n
#line 949 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[360]; //         </div>\n      </div>\n    </div>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 965 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[363]; //   <a href="/tvscraper/
#line 969 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[364]; // " target="_blank">\n    <img src="/tvscraper/
#line 970 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[365]; // " class="artwork" />\n  </a>\n
#line 972 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[367]; //   <div class="epg_description" id="aboutBox">\n    <div class="station">\n      <div class="boxheader"><div><div class="caption">
#line 981 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[368]; // </div></div></div>\n    </div>\n    <div class="epg_content">\n      <div>\n        <div class="about_head"><div><div>
#line 985 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[369]; // </div></div></div>\n        <div class="about_left">
#line 986 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[370]; // :</div>\n        <div class="about_right">Thomas Keil (Thomas)</div>\n        <div class="about_left">
#line 988 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[371]; // :</div>\n        <div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n        <div class="about_left">
#line 990 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[372]; // :</div>\n        <div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n        <div class="about_left">
#line 992 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[373]; // :</div>\n        <div class="about_right">Jasmin Jessich (jasminj)</div>\n        <div class="about_left">
#line 994 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[374]; // :</div>\n        <div class="about_right">Dieter Hametner (tadi)</div>\n        <div class="about_left">
#line 996 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[375]; // :</div>\n        <div class="about_right">Christian Wieninger (winni)</div>\n        <div class="about_left">
#line 998 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[376]; // :</div>\n        <div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n        <div class="about_head"><div><div>
#line 1000 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[377]; // </div></div></div>\n        <div class="about_left">
#line 1001 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[378]; // :</div>\n        <div class="about_right">
#line 1002 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1002 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[379]; // </div>\n        <div class="about_left">
#line 1003 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[380]; // :</div>\n        <div class="about_right">
#line 1004 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[381]; // </div>\n        <div class="about_head"><div><div>
#line 1005 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[382]; // </div></div></div>\n        <div class="about_left">EPGsearch:</div>\n        <div class="about_right">\n
#line 1008 "pageelems.ecpp"
          Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[383]; //           <img align="center" src="
#line 1009 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[384]; // "/>\n
#line 1010 "pageelems.ecpp"
          if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[385]; //             
#line 1011 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[386]; // : 
#line 1011 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[387]; // \n
#line 1012 "pageelems.ecpp"
          } else {

  reply.out() << _tntChunks[388]; //             
#line 1013 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[389]; // : 
#line 1013 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[390]; // \n
#line 1014 "pageelems.ecpp"
          }

  reply.out() << _tntChunks[391]; //           (<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1015 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[392]; // </a>)<br/>\n        </div>\n        <div class="about_left">Streamdev server:</div>\n        <div class="about_right">\n
#line 1019 "pageelems.ecpp"

          Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[393]; //           <img align="center" src="
#line 1022 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[394]; // "/>\n
#line 1023 "pageelems.ecpp"

          if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[395]; //             
#line 1026 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[396]; // : 
#line 1026 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[397]; // \n
#line 1027 "pageelems.ecpp"

          } else {

  reply.out() << _tntChunks[398]; //             
#line 1030 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[399]; // : 
#line 1030 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[400]; // \n
#line 1031 "pageelems.ecpp"

          }

  reply.out() << _tntChunks[401]; //           (<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1034 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[402]; // </a>)<br/>\n        </div>\n        <div class="about_left">tvscraper:</div>\n        <div class="about_right">\n
#line 1038 "pageelems.ecpp"
          Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[403]; //           <img align="center" src="
#line 1039 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[404]; // "/>\n
#line 1040 "pageelems.ecpp"
          if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[405]; //             
#line 1041 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[406]; // : 
#line 1041 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[407]; // \n
#line 1042 "pageelems.ecpp"
          } else {

  reply.out() << _tntChunks[408]; //             
#line 1043 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[409]; // : 
#line 1043 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[410]; // \n
#line 1044 "pageelems.ecpp"
          }

  reply.out() << _tntChunks[411]; //           (<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1045 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[412]; // </a>)<br/>\n        </div>\n        <div class="about_head"><div><div>
#line 1047 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[413]; // </div></div></div>\n        <div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB.</div>\n        <div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them.</a></div>\n        <div class="about_head"><div><div>
#line 1050 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[414]; // </div></div></div>\n        <div class="about_line">
#line 1051 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[415]; // :<br/>\n          <a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n        <div class="about_head"><div><div>&nbsp;</div></div></div>\n      </div>\n    </div>\n  </div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
